unit unHlavni;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TfoHlavni = class(TForm)
    OpenD: TOpenDialog;
    Panel1: TPanel;
    Label1: TLabel;
    inZvetseni: TTrackBar;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    chCesty: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    Mapa1: TMenuItem;
    Nahrtmapu1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    Nstroje1: TMenuItem;
    meOkolni: TMenuItem;
    meCesta: TMenuItem;
    procedure inZvetseniChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chCestyClick(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Nahrtmapu1Click(Sender: TObject);
    procedure meOkolniClick(Sender: TObject);
    procedure meCestaClick(Sender: TObject);
  private
    { Private declarations }
    procedure ZobrazMapu;
  public
    { Public declarations }
  end;

var
  foHlavni: TfoHlavni;

type
   tMesto = record
      nazev: string;
      polohaX, polohaY: integer;
   end;
   tCesta = record
      iZ, iDo: integer; // slo msta
      Vzdalenost, PrumRych: Currency;
   end;
   tSpotreba = record
      rychlost, litru: Currency;
   end;

var
   mesta: array of tMesto;
   cesty: array of tCesta;
   spotreby: array of tSpotreba;
   mapaMinX, mapaMinY, mapaMaxX, mapaMaxY: integer;
   minRychlost, maxRychlost: Currency;

const maxBuf = 10000;
      rezervaX = 200;
      rezervaY = 30;

function CisloMesta(const s: string): integer;



implementation

uses unOkolni, unCesta;

{$R *.dfm}

// funkce na zklad jmna msta zjist jeho polohu v seznamu
function CisloMesta(const s: string): integer;
var i: integer;
begin
   Result := -1;
   for i := 0 to High(Mesta) do
      if Mesta[i].nazev = s then Result := i;
end;


// tato procedura ulo seznam mst do komponenty ListBox
procedure UlozMestaDoListBoxu(LB: tListBox);
var i: integer;
begin
   LB.Items.Clear;
   for i := 0 to High(Mesta) do
      LB.Items.Add(Mesta[i].nazev);
   LB.ItemIndex := 0;
end;


procedure TfoHlavni.ZobrazMapu;
var i, zvetseni, x, y: integer;
    bmp: tBitmap;
begin
   if length(Mesta) = 0 then exit;
   zvetseni := inZvetseni.Position;

   // mapu vykreslm do objektu tBitmap - to je rychlej ne, kreslen pmo na obrazovku
   bmp := tBitmap.Create;
   try
      Screen.Cursor := crHourGlass;
      bmp.Width  := (mapaMaxX - mapaMinX) * zvetseni + rezervaX;
      bmp.Height := (mapaMaxY - mapaMinY) * zvetseni + rezervaY;

      // vykreslm cesty mezi msty
      bmp.Canvas.Pen.Width := 5;
      if chCesty.Checked then
         for i := 0 to High(Cesty) do
            with Cesty[i] do
               if (iZ >= 0) and (iDo >= 0) then begin
                  bmp.Canvas.Pen.Color :=
                     RGB(  255 - Round((PrumRych - minRychlost) / (maxRychlost - minRychlost) * 128),
                           255 - Round((PrumRych - minRychlost) / (maxRychlost - minRychlost) * 128),
                           255  );
                  bmp.Canvas.MoveTo(
                     (Mesta[iZ].polohaX - mapaMinX) * zvetseni + 5,
                     (Mesta[iZ].polohaY - mapaMinY) * zvetseni + 7 );
                  bmp.Canvas.LineTo(
                     (Mesta[iDo].polohaX - mapaMinX) * zvetseni + 5,
                     (Mesta[iDo].polohaY - mapaMinY) * zvetseni + 7 );
               end;
      bmp.Canvas.Pen.Width := 1;
      bmp.Canvas.Pen.Color := clBlack;

      // vykreslm nzvy mst
      bmp.Canvas.Brush.Color := clWhite;
      for i := 0 to High(mesta) do
         with mesta[i] do begin
            x := (polohaX - mapaMinX) * zvetseni;
            y := (polohaY - mapaMinY) * zvetseni;
            bmp.Canvas.TextOut(x+11, y, nazev);
         end;

      // vykreslm erven teky u mst   
      bmp.Canvas.Brush.Color := clRed;
      for i := 0 to High(mesta) do
         with mesta[i] do begin
            x := (polohaX - mapaMinX) * zvetseni;
            y := (polohaY - mapaMinY) * zvetseni;
            bmp.Canvas.Ellipse(x, y+2, x+10, y+12);
         end;
      Image1.Picture.Assign(bmp);
   finally
      Screen.Cursor := crDefault;
      bmp.Free;
   end;
end;


procedure TfoHlavni.inZvetseniChange(Sender: TObject);
begin
   ZobrazMapu;
end;

procedure TfoHlavni.FormCreate(Sender: TObject);
begin
   SetLength(mesta, 0);
end;

procedure TfoHlavni.chCestyClick(Sender: TObject);
begin
   ZobrazMapu;
end;

procedure TfoHlavni.Konec1Click(Sender: TObject);
begin
   Close;
end;


function StrToCurr2(s: string): currency;
var p: integer;
begin
   p := pos('.', s);
   if p > 0 then s[p] := ',';
   Result := StrToCurr(s);
end;


procedure TfoHlavni.Nahrtmapu1Click(Sender: TObject);
type tCoCtu = (ccNic, ccMapa,
                  ccMesta, ccMesto, ccNazev, ccPolohaX, ccPolohaY,
                  ccCesty, ccCesta, ccZ, ccDo, ccVzdalenost, ccPrumRych,
                  ccSpotreby, ccSpotreba, ccRychlost, ccLitru);
var f: file;
    buf: array [0..maxBuf-1] of char;
    iBuf, nBuf, i: integer;
    CtuJmenoTagu: boolean;
    JmenoTagu, ObsahTagu: string;
    Znak: char;
    CoCtu: tCoCtu;
begin

   // Natu mapu ze souboru.
   // Natn funguje jako stavov automat - v promnnch
   // CoCtu a CtuJmenoTagu je uloen aktuln stav natn.
   if not OpenD.Execute then exit;
   foCesta.JeAktualni := false;
   AssignFile(f, OpenD.FileName);
   FileMode := fmOpenRead;   // oteven pouze pro ten
   Reset(f, 1);
   Screen.Cursor := crHourGlass;
   try
      CtuJmenoTagu := false;
      CoCtu := ccNic;
      JmenoTagu := '';
      ObsahTagu := '';
      SetLength(mesta, 0);
      SetLength(cesty, 0);
      SetLength(spotreby, 0);
      repeat
         BlockRead(f, buf, maxBuf, nBuf);
         for iBuf := 0 to nBuf - 1 do begin
            Znak := buf[iBuf];
            if CtuJmenoTagu then
               if znak = '>' then begin
                  if (CoCtu = ccNic) and (JmenoTagu = 'MAPA') then CoCtu := ccMapa;
                  if (CoCtu = ccMapa) and (JmenoTagu = '/MAPA') then CoCtu := ccNic;
                  if (CoCtu = ccMapa) and (JmenoTagu = 'MESTA') then CoCtu := ccMesta;
                  if (CoCtu = ccMesta) and (JmenoTagu = '/MESTA') then CoCtu := ccMapa;
                  if (CoCtu = ccMesta) and (JmenoTagu = 'MESTO') then begin
                     SetLength(mesta, Length(mesta) + 1);
                     with mesta[high(mesta)] do begin
                        nazev := '';
                        polohaX := 0;
                        polohaY := 0;
                     end;
                     CoCtu := ccMesto;
                  end;
                  if (CoCtu = ccMesto) and (JmenoTagu = '/MESTO') then CoCtu := ccMesta;
                  if (CoCtu = ccMesto) and (JmenoTagu = 'NAZEV') then CoCtu := ccNazev;
                  if (CoCtu = ccNazev) and (JmenoTagu = '/NAZEV') then begin
                     mesta[high(mesta)].nazev := ObsahTagu;
                     CoCtu := ccMesto;
                  end;
                  if (CoCtu = ccMesto) and (JmenoTagu = 'POLOHAX') then CoCtu := ccPolohaX;
                  if (CoCtu = ccPolohaX) and (JmenoTagu = '/POLOHAX') then begin
                     mesta[high(mesta)].polohaX := StrToInt(ObsahTagu);
                     CoCtu := ccMesto;
                  end;
                  if (CoCtu = ccMesto) and (JmenoTagu = 'POLOHAY') then CoCtu := ccPolohaY;
                  if (CoCtu = ccPolohaY) and (JmenoTagu = '/POLOHAY') then begin
                     mesta[high(mesta)].polohaY := StrToInt(ObsahTagu);
                     CoCtu := ccMesto;
                  end;
                  if (CoCtu = ccMapa) and (JmenoTagu = 'CESTY') then CoCtu := ccCesty;
                  if (CoCtu = ccCesty) and (JmenoTagu = '/CESTY') then CoCtu := ccMapa;
                  if (CoCtu = ccCesty) and (JmenoTagu = 'CESTA') then begin
                     SetLength(cesty, Length(cesty) + 1);
                     with cesty[high(cesty)] do begin
                        iZ := -1;
                        iDo := -1;
                        Vzdalenost := 1;
                        PrumRych := 1;
                     end;
                     CoCtu := ccCesta;
                  end;
                  if (CoCtu = ccCesta) and (JmenoTagu = '/CESTA') then CoCtu := ccCesty;
                  if (CoCtu = ccCesta) and (JmenoTagu = 'Z') then CoCtu := ccZ;
                  if (CoCtu = ccZ) and (JmenoTagu = '/Z') then begin
                     cesty[high(cesty)].iZ := CisloMesta(ObsahTagu);
                     CoCtu := ccCesta;
                  end;
                  if (CoCtu = ccCesta) and (JmenoTagu = 'DO') then CoCtu := ccDO;
                  if (CoCtu = ccDO) and (JmenoTagu = '/DO') then begin
                     cesty[high(cesty)].iDo := CisloMesta(ObsahTagu);
                     CoCtu := ccCesta;
                  end;
                  if (CoCtu = ccCesta) and (JmenoTagu = 'VZDALENOST') then CoCtu := ccVzdalenost;
                  if (CoCtu = ccVzdalenost) and (JmenoTagu = '/VZDALENOST') then begin
                     cesty[high(cesty)].Vzdalenost := StrToCurr2(ObsahTagu);
                     CoCtu := ccCesta;
                  end;
                  if (CoCtu = ccCesta) and (JmenoTagu = 'PRUMERNARYCHLOST') then CoCtu := ccPrumRych;
                  if (CoCtu = ccPrumRych) and (JmenoTagu = '/PRUMERNARYCHLOST') then begin
                     cesty[high(cesty)].PrumRych := StrToCurr2(ObsahTagu);
                     CoCtu := ccCesta;
                  end;
                  if (CoCtu = ccMapa) and (JmenoTagu = 'SPOTREBY') then CoCtu := ccSpotreby;
                  if (CoCtu = ccSpotreby) and (JmenoTagu = '/SPOTREBY') then CoCtu := ccMapa;
                  if (CoCtu = ccSpotreby) and (JmenoTagu = 'SPOTREBA') then begin
                     SetLength(spotreby, Length(spotreby) + 1);
                     with spotreby[high(spotreby)] do begin
                        rychlost := 1;
                        litru := 1;
                     end;
                     CoCtu := ccSpotreba;
                  end;
                  if (CoCtu = ccSpotreba) and (JmenoTagu = '/SPOTREBA') then CoCtu := ccSpotreby;
                  if (CoCtu = ccSpotreba) and (JmenoTagu = 'RYCHLOST') then CoCtu := ccRychlost;
                  if (CoCtu = ccRychlost) and (JmenoTagu = '/RYCHLOST') then begin
                     spotreby[high(spotreby)].Rychlost := StrToCurr2(ObsahTagu);
                     CoCtu := ccSpotreba;
                  end;
                  if (CoCtu = ccSpotreba) and (JmenoTagu = 'LITRU') then CoCtu := ccLitru;
                  if (CoCtu = ccLitru) and (JmenoTagu = '/LITRU') then begin
                     spotreby[high(spotreby)].litru := StrToCurr2(ObsahTagu);
                     CoCtu := ccSpotreba;
                  end;
                  CtuJmenoTagu := false;
                  ObsahTagu := '';
               end
               else
                  JmenoTagu := JmenoTagu + UpCase(znak)
            else
               if znak = '<' then begin
                  CtuJmenoTagu := true;
                  JmenoTagu := '';
               end
               else
                  ObsahTagu := ObsahTagu + znak;
         end;
      until nBuf < maxBuf;
   finally
      Screen.Cursor := crDefault;
      CloseFile(f);
   end;
   if Length(mesta) = 0 then begin
      MessageDlg('Mapa je przdn!', mtWarning, [mbOK], 0);
      exit;
   end;

   // zjistm velikost mapy
   with mesta[0] do begin
      mapaMinX := polohaX;
      mapaMaxX := polohaX;
      mapaMinY := polohaY;
      mapaMaxY := polohaY;
   end;
   for i := 1 to High(mesta) do
      with mesta[i] do begin
         if polohaX < mapaMinX then mapaMinX := polohaX;
         if polohaX > mapaMaxX then mapaMaxX := polohaX;
         if polohaY < mapaMinY then mapaMinY := polohaY;
         if polohaY > mapaMaxY then mapaMaxY := polohaY;
      end;

   // zjistm rozsah prmrnch rychlost (pro barevn rozlien)
   if Length(Cesty) = 0 then begin
      minRychlost := 1;
      maxRychlost := 1;
   end
   else begin
      minRychlost := Cesty[0].PrumRych;
      maxRychlost := Cesty[0].PrumRych;
      for i := 1 to High(Cesty) do
         with cesty[i] do begin
            if PrumRych < minRychlost then minRychlost := PrumRych;
            if PrumRych > maxRychlost then maxRychlost := PrumRych;
         end;
   end;

   // zobrazm mapu
   ZobrazMapu;
   meOkolni.Enabled := true;
   meCesta.Enabled := true;
end;

procedure TfoHlavni.meOkolniClick(Sender: TObject);
begin
   with foOkolni do begin
      UlozMestaDoListBoxu(inMesto);
      inMestoClick(nil);
      ShowModal;
   end;
end;

procedure TfoHlavni.meCestaClick(Sender: TObject);
begin
   with foCesta do begin
      if not JeAktualni then begin
         UlozMestaDoListBoxu(inOdkud);
         UlozMestaDoListBoxu(inKam);
         JeAktualni := true;
         inMestoClick(nil);
      end;
      ShowModal;
   end;
end;

end.

